## siconos 4.3.1+dfsg

=== CMakeLists.txt ===
#===============================================================================
# cmake utility to compile and install siconos.
#
#
# Siconos development team - September 2015.
#
#===============================================================================

# ============= Global 'standard' cmake Settings =============

# Set minimum version for cmake
# We advise 3.12 at least, but 3.7 is authorized since it's the default version on current debian stable.
cmake_minimum_required(VERSION 3.7)
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12")
  cmake_policy(SET CMP0074 NEW)
endif()


# Set cmake modules directories
# (i.e. the those which contain all user-defined FindXXX.cmake files among other things)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/docs/cmake)

# Improve cmake interface when current version is too old.
include(new_cmake_functions)

# Force out-of-source build
if ("${CMAKE_SOURCE_DIR}" MATCHES "${CMAKE_BINARY_DIR}")
  message (SEND_ERROR "In source building not supported (not recommanded indeed). You need to :
    * cleanup your source directory :  \"rm -rf ./CMakeFiles/ ./CMakeCache.txt\"
    * try configure process again in a new directory
    (e.g. mkdir <anywhere>/build ; cd <anywhere>/build ; cmake ${CMAKE_SOURCE_DIR}) ...")
  return()
endif()

# If not given, turn build type to release mode.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release." FORCE)
endif()

# Some useful macros and functions
include(SiconosTools)
# Some python tools and functions, used to configure the project, called by cmake.
configure_file(scripts/buildtools.py share/buildtools.py COPYONLY)

# cmake project name
set(PROJECT_NAME siconos)

# Get current year (for licence and other cartridges)
find_program(DATE_COMMAND date)
if(DATE_COMMAND)
  execute_process(COMMAND date "+\"%Y\"" OUTPUT_VARIABLE YEAR)
  string(STRIP ${YEAR} YEAR)
endif()
# Read user option file, if provided on command line
if(USER_OPTIONS_FILE)
  # Check for tilde in file name (not handled properly by cmake)
  string(FIND ${USER_OPTIONS_FILE} "\~" res)
  if(res EQUAL 0)
    string(REPLACE "\~" "$ENV{HOME}" USER_OPTIONS_FILE ${USER_OPTIONS_FILE})
  endif()
  if(NOT IS_ABSOLUTE ${USER_OPTIONS_FILE})
    get_filename_component(USER_OPTIONS_FILE ${USER_OPTIONS_FILE} REALPATH
      BASE_DIR ${CMAKE_CURRENT_BINARY_DIR})
  endif()
  message("\n !!!!! Load user-defined options set from file ${USER_OPTIONS_FILE} !!!!! \n")
  # Configure to take into account any change in ${USER_OPTIONS_FILE}
  configure_file(${USER_OPTIONS_FILE} current_options.cmake COPYONLY)
  include(${CMAKE_CURRENT_BINARY_DIR}/current_options.cmake)
else()
  message("\n !!!!! Load default configuration set from file ${CMAKE_SOURCE_DIR}/cmake/default_options.cmake !!!!! \n")
  include(default_options)
endif()

# Set target names from components list
if(NOT COMPONENTS)
  message(WARNING "Components list is empty - Nothing will be built.")
endif()

set(AVAILABLE_COMPONENTS "externals numerics kernel control mechanics mechanisms io")
foreach(component_name IN LISTS COMPONENTS)
  # Check and set components list
  string(TOUPPER ${component_name} upname)
  list(FIND ${AVAILABLE_COMPONENTS} ${component_name} comp_exists)
  if(NOT comp_exists)
    message(FATAL_ERROR "Unknown siconos component : ${component_name}")
  endif()
  set(HAVE_SICONOS_${upname} TRUE)
endforeach()
if(HAVE_SICONOS_KERNEL AND NOT WITH_CXX)
  message(FATAL_ERROR "You can not build kernel component without C++. Please set WITH_CXX=ON.")
endif()
  


# Get last component in the list;
# It might be usefull to set some dependencies in targets.
list(GET COMPONENTS -1 last_component)
# ============= The project =============
# Set project name and project languages
# Languages:
# - Fortran is optional, needed by ql0001, lsodar, hem5 solvers.
# - CXX is required for kernel and following components
# - C always required

if(WITH_CXX)
  project(${PROJECT_NAME} CXX C) # C or not C ?
  set(CMAKE_CXX_STANDARD 11)
else()
  # we may need to compile only numerics and only in C.
  # Really???
  project(${PROJECT_NAME} C)
endif()

if(LLVM_ANALYSE)
  set(CMAKE_C_OUTPUT_EXTENSION ".bc")
endif()

# Activate fortran, if needed.
if(WITH_FORTRAN)
  enable_language(Fortran)
  include(FCompilerSetup)
  set(HAS_FORTRAN TRUE)
endif()

# Common setup
include(SiconosSetup)

# ========= Python bindings =========
if(WITH_PYTHON_WRAPPER)
  add_subdirectory(wrap)
endif()

# ========= Tests setup =========
if(WITH_TESTING)
  include(CTest)
  include(SiconosCTest)
  # log file for tests setup
  file(WRITE ${CMAKE_BINARY_DIR}/tests.log "--- Siconos tests setup --- \n")
endif()

# ========= Documentation setup =========
# This includes doxygen_warnings,
# doxygen doc from source files, sphinx doc
# and docstrings from doxygen, depending on the
# enabled options.
add_subdirectory(docs)

# ========= Setup each required component =========
foreach(COMPONENT IN LISTS COMPONENTS)
  message("\n--------------------------------------------------")
  add_subdirectory(${COMPONENT})
endforeach()

# ========= Documentation setup =========
# Finalize documentation setups.
# Must be called AFTER each component config.
finalize_doc()

include(FeatureSummary)
feature_summary(WHAT ALL)

# ============= Siconos Package configuration =============
# i.e. what should be generated/configured at install.
include(SiconosPackageSetup)

# SiconosConfig.h generation and include
if(EXISTS ${CMAKE_SOURCE_DIR}/config.h.cmake)
  # Warning : strongly depends on find_package(...) results.
  configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake
    ${CMAKE_BINARY_DIR}/SiconosConfig.h)
  if(SHOW_ME_SICONOS_CONFIG)
    file(READ ${CMAKE_BINARY_DIR}/SiconosConfig.h SICONOS_CONFIG_H)
    message(${SICONOS_CONFIG_H})
  endif()
  install(FILES ${CMAKE_BINARY_DIR}/SiconosConfig.h DESTINATION include/${PROJECT_NAME})
endif()


# man pages
if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/man)
  configure_file(man/siconos.1.in man/siconos.1)
  install(FILES ${CMAKE_BINARY_DIR}/man/siconos.1 DESTINATION share/man/man1)
endif()

# ============= Summary =============
message(STATUS "\n============================================ Summary ============================================")
message(STATUS "${PROJECT_NAME} version ${SICONOS_VERSION} is now ready for compilation and installation.")
message(STATUS "To proceed run 'make' and 'make install' and optionaly 'make test'.")
message(STATUS "C++ Compiler : ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "C++ flags : ${CMAKE_CXX_FLAGS}")
message(STATUS "C Compiler : ${CMAKE_C_COMPILER} ${CMAKE_C_COMPILER_VERSION}")
message(STATUS "C flags : ${CMAKE_C_FLAGS}")
message(STATUS "Fortran Compiler : ${CMAKE_Fortran_COMPILER} ${CMAKE_Fortran_COMPILER_VERSION}")
message(STATUS "Fortran flags : ${CMAKE_Fortran_FLAGS}")
message(STATUS "Compilation mode is : ${CMAKE_BUILD_TYPE}")
message(STATUS "Code Sources are in : ${CMAKE_SOURCE_DIR}")
message(STATUS "Blas from ${BLAS_NAME}.")
message("    Blas libraries : ${BLAS_LIBRARIES}.")
message("    Blas headers : ${BLAS_HEADER} in ${BLAS_INCLUDE_DIR}.")
message(STATUS "Lapack config:")
message("    Lapack libraries : ${LAPACK_LIBRARIES}.")
message("    Lapack headers : ${LAPACK_HEADER} in ${LAPACK_INCLUDE_DIR}.")
if(WITH_SYSTEM_SUITESPARSE)
  message(STATUS "Use system-provided SuiteSparse library, with:")
  message("    - CXSparse headers path: ${SuiteSparse_CXSparse_INCLUDE_DIR}")
  message("    - CXSparse library : ${SuiteSparse_CXSparse_LIBRARY}")
else()
  message(STATUS "Use Siconos-provided SuiteSparse, with:")
  message("    - CXSparse headers path : externals/SuiteSparse/CXSparse")
endif()
message(STATUS "Python interpreter is ${Python3_EXECUTABLE}")
if(WITH_PYTHON_WRAPPER)
  message(STATUS "Python libraries are ${Python3_LIBRARIES}")
endif()
message(STATUS "The project will be installed in ${CMAKE_INSTALL_PREFIX}")
if(WITH_PYTHON_WRAPPER)
  message(STATUS "${SICONOS_PYTHON_PACKAGE} python package will be installed in ${SICONOS_PYTHON_INSTALL_DIR}")
endif()
message(STATUS "To get more information about dependencies, config or else, ")
message(STATUS "check CMakeCache.txt file or re-run cmake with -DPRINT_ENV=ON.")
message(STATUS "=================================================================================================\n")

# Log build info into ${CMAKE_BINARY_DIR}/Testing/Notes/Build
write_notes()

=== docs/CMakeLists.txt ===
# ============================================================
# Prepare  config to generate siconos documentation :
#
# - automatic doxygen documentation, from source code
# - sphinx documentation for manuals
# 
# ============================================================
include(FindPythonModule)
include(FindSphinxModule)

# Devel option : generate pure doxygen doc (no sphinx), extracting all and with graphs.
option(USE_DEVEL_DOXYGEN "Build doxygen (html, latex ...) doc, extracting all. Devel purpose. Default = OFF" OFF)


# -- Doc config --
# Name and create build path for documentation
set(DOC_ROOT_DIR ${CMAKE_BINARY_DIR}/docs/build CACHE INTERNAL "Root path to generated documentation.")
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/html)
# -- Gendoctools install --
# gendoctools is installed in binary dir as a python package
# used to generate docstrings, rst files and so on.
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gendoctools/__init__.py.in ${CMAKE_BINARY_DIR}/share/gendoctools/__init__.py @ONLY)
file(GLOB files_py RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/gendoctools/*.py)
foreach(fname IN LISTS files_py)
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/${fname}"
    "${CMAKE_BINARY_DIR}/share/${fname}" COPYONLY)
endforeach()
if(WITH_DOXY2SWIG)
  configure_file(${CMAKE_SOURCE_DIR}/externals/swig/doxy2swig.py ${CMAKE_BINARY_DIR}/share/gendoctools/doxy2swig.py COPYONLY)
endif()

# configure_file(${CMAKE_CURRENT_SOURCE_DIR}/replace_py_escape.sh ${CMAKE_BINARY_DIR}/share/replace_py_escape.sh COPYONLY)

#  ====== doxygen documentation setup ======
# This setup is required if one at least of
# the following is needed:
# - doxygen warnings (see WITH_DOXYGEN_WARNINGS)
# - python docstrings from doxygen (xml) (see WITH_DOXY2SWIG)
# - doxygen documentation generated from source files (see WITH_DOCUMENTATION)
if(USE_DOXYGEN)

  # Search doxygen and set config
  find_package(Doxygen REQUIRED)
  # Output path for doxygen documentation
  if(NOT DOXYGEN_OUTPUT)
    set(DOXYGEN_OUTPUT ${DOC_ROOT_DIR}/doxygen CACHE INTERNAL "Path to doxygen outputs.")
  endif()
  file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT}/man)
  
  # --- Config files and their options. --
  # --> a lot for doxygen warnings (from doxy_warnings.config.in)
  # --> one for documentation (html and xml to sphinx) (from doxy.config.in)

  # == set configuration file for doxygen warnings ==
  #  - Results in binary_dir/doxygen_warnings
  #  - input config from config/doxy_warnings.config
  #  - only xml output.
  if(WITH_DOXYGEN_WARNINGS)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings/man)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings/xml)
    set(DOXY_WARNINGS_CONFIG ${CMAKE_CURRENT_SOURCE_DIR}/config/doxy_warnings.config.in CACHE INTERNAL "config file for doxygen warnings output.")
    # All the configure process will be done for each component
    # thanks to 'include(doxygen_warnings)'. See LibraryProjectSetup.

    # A target to filter out doxygen warnings : remove empty files and concatenate the others.
    # call python function from gendoctools (filter_doxygen_warnings_files).
    add_custom_target(filter_warnings
      COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_BINARY_DIR}/share ${PYTHON_EXECUTABLE} -c
      "from gendoctools.filters import filter_doxygen_warnings_files as f; f('${CMAKE_BINARY_DIR}/doxygen_warnings', 'SUMMARY.warnings')"
      VERBATIM
      COMMENT "Filter doxygen warnings (result : SUMMARY.warnings)."
      DEPENDS ${last_component} # No warnings if siconos has not been compiled. Should we remove this dep ? 
      )
  endif()
endif()

  
#  ====== Create a Target to generate documentation ======
if(WITH_DOCUMENTATION)

  # --- Search dependencies required to build documentation ---
  message("--------------------------------------------------")
  message("------ Start global setup for documentation ------\n")
  if(Python3_VERSION VERSION_LESS 3.6)
    message(FATAL_ERROR "Python >= 3.6 is required to generate documentation.")
  endif()
  find_python_module(breathe REQUIRED)
  find_python_module(sphinx REQUIRED)
  find_sphinx_module(sphinxcontrib bibtex REQUIRED)
  find_sphinx_module(sphinxcontrib youtube)

  if(NOT ${youtube_FOUND})
    # This python package can not be found using standard ways such as conda or pip,
    # so we force download and install.
    message("Can not found sphinxcontrib-youtube. It will be downloaded and installed ...")
    execute_process(
      COMMAND ${PYTHON_EXECUTABLE} -m pip install git+https://github.com/sphinx-contrib/youtube.git)
    find_sphinx_module(sphinxcontrib youtube REQUIRED)
  endif()
  # Sphinx theme for documentation
  find_python_module(sphinx_bootstrap_theme REQUIRED)

  # --- copy/conf sphinx files into build directory ---

  # main page
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/index.rst.in"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/index.rst" @ONLY)

  # siconos biblio
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/siconos.bib"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/siconos.bib" COPYONLY)

  # List and copy all rst files from source dir to binary dir
  file(GLOB_RECURSE files_rst RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/sphinx
    ${CMAKE_CURRENT_SOURCE_DIR}/sphinx/*.rst)
  foreach(filepath IN LISTS files_rst)
    #get_filename_component(filename ${filepath} NAME)
    
    configure_file (
      "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/${filepath}"
      "${CMAKE_CURRENT_BINARY_DIR}/sphinx/${filepath}" COPYONLY)
  endforeach()
  
  # css
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/_static/biblio.css"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/_static/biblio.css" COPYONLY)

  # !! conf.py.in must be copied later, after doxygen setup !!
  # Done during finalize_doc call.
  
  # --- Build a target for sphinx ---
  # --> use make html or make latex ... to build documentation.
  set(SPHINX_EXECUTABLE sphinx-build)
  set(SPHINX_LOG_FILE ${CMAKE_BINARY_DIR}/docs/sphinx_warnings.log)    
  set(SPHINX_PARAMETERS
    -w ${SPHINX_LOG_FILE}
    -b html # html output
    -d build/doctrees # path to doctree files
    ${CMAKE_CURRENT_BINARY_DIR}/sphinx  # path to rst source
    )

  # - Target to copy figures required by sphinx from source to binary dir -
  #  make copy-sphinx-figures
  add_custom_target(copy-sphinx-figures
    COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/sphinx/figures ${CMAKE_CURRENT_BINARY_DIR}/sphinx/figures
    )

  # -- Target to generate rst files from sources (C/C++/python) --
  #  1. creates rst files in a breathe-ready format from xml outputs of doxygen run on C/C++ headers
  #  2. creates rst files from 'autodoc' outputs, docstrings, or others python doc. things.
  add_custom_target(rst_api
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_BINARY_DIR}/share ${PYTHON_EXECUTABLE} -c
    "from gendoctools.generate_api import build_rst_api as f; f('${CMAKE_CURRENT_BINARY_DIR}/sphinx')"
    VERBATIM
    COMMENT "Create main rst files for C/C++ and python API.")
  
  # -- To build html doc : make html --
  add_custom_target(html
    COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_PARAMETERS} 2> errors.txt ${CMAKE_CURRENT_BINARY_DIR}/build/html
    VERBATIM
    DEPENDS copy-sphinx-figures rst_api
    )

  # post command to make html : filter sphinx warnings to a log file.
  add_custom_command(TARGET html POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_BINARY_DIR}/share ${PYTHON_EXECUTABLE} -c
    "from gendoctools.filters import filter_sphinx_warnings as f; f('${SPHINX_LOG_FILE}')"
    VERBATIM
    COMMENT "Filtering sphinx logfile into ${SPHINX_LOG_FILE}.")
  
  add_custom_command(TARGET html POST_BUILD
    COMMENT "Done. Sphinx doc has been generated in ${DOC_ROOT_DIR}/html")
  
  # -- To build latex doc : make latex -- 
  set(SPHINX_LATEX_PARAMETERS
    -b latex # latex output
    -d build/doctrees # path to doctree files
    ${CMAKE_CURRENT_BINARY_DIR}/sphinx  # path to rst source
    )
  
  add_custom_target(latex
    COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_LATEX_PARAMETERS}
    ${CMAKE_CURRENT_BINARY_DIR}/build/latex
    )

  add_custom_target(doc DEPENDS html)

  message("------ End global setup for documentation ------\n")


endif()

=== docs/requirements.txt ===
scipy
lxml
pytest
matplotlib
h5py
sphinx<2.0
sphinx-rtd-theme
sphinxcontrib-bibtex
sphinxcontrib-websupport
sphinx-bootstrap-theme
sphinxcontrib-napoleon
numpydoc
breathe

=== externals/CMakeLists.txt ===
#================================================================
# cmake utilities to build external component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time


# Component name (i.e. target name)
set(COMPONENT externals)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
set(${COMPONENT}_DIRS
  hairer
  netlib/dftemplates
  netlib/odepack
  optim_misc
  optim_misc/ql0001
  SOL/lumod-c
  sort
  tools
)

# boost extras, when c++ is on only
if(WITH_CXX)
  list(APPEND ${COMPONENT}_DIRS numeric_bindings boost_contribs)
  if(WITH_SERIALIZATION AND NOT WITH_SYSTEM_BOOST_SERIALIZATION)
    # FP : in which case do we need this, since boost serialization is required ??
    list(APPEND ${COMPONENT}_DIRS boost_serialization)
  endif()
endif()

# -- Source files to be excluded from build --
set(${COMPONENT}_EXCLUDE_SRCS "SOL/lumod-c/sparselib.c" "SOL/lumod-c/lumod_sparse.c")

# --- Sort ---
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/sort/sort.h")
  if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/sort/sort_common.h")
    set(HAVE_SORT TRUE CACHE INTERNAL "True if sort is available in externals.")
  endif()
endif()

# --- ql0001 ---
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/optim_misc/ql0001/ql0001.f")
  set(HAVE_QL0001 TRUE CACHE INTERNAL "True if ql0001 is available in externals.")
endif()

# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
# No docs for externals.
set(${COMPONENT}_EXCLUDE_DOXY ${${COMPONENT}_DIRS})


# TEST TEST TEST
# ------ include interface ------
# What is needed at build time
# by other targets (numerics etc) to compile with externals.
# It means that a call to
#  target_link_libraries(truc PRIVATE externals)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES
  netlib
   netlib/odepack  # For odepack.h in tests and kernel
   tools           # For SiconosCompat.h in numerics 
   blas_lapack     # For SiconosLapack.h in numerics
   SOL/lumod-c # For lumod_dense.h in numerics
   hairer # For kernel
   )

if(WITH_CXX)
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES
    numeric_bindings boost_contribs) # SiconosAlgebra needs this
endif()

if(HAVE_SORT)
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES sort) # NumericsSparseMatrix needs this
endif()

if(NOT WITH_SYSTEM_SUITESPARSE)
  # else suite sparse is an external dependency of numerics and handled in numerics
  # CMakeLists.txt.
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES SuiteSparse/CXSparse)
endif()
# TEST TEST TEST

# ---- Final setup for the library ----

# Windows stuff --> should probably be reviewed and updated
include(WindowsExternalsSetup)

# -- create/setup component target --
include(ComponentSetup)
create_siconos_component(${COMPONENT})

# --- python bindings ---
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  add_subdirectory(swig)
endif()
  
if(WITH_PYTHON_WRAPPER)
  add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
endif()  

# - Extra setup for the component -
if(GAMSCAPI_FOUND AND CMAKE_DL_LIBS) # needed by GAMS (?). Here or in numerics ?
  target_link_libraries(externals PRIVATE ${CMAKE_DL_LIBS})
endif()

# Force c++ compiler for c files (for Visual Studio I guess?)
if(BUILD_AS_CPP)
  file(GLOB_RECURSE C_FILES ${CMAKE_CURRENT_SOURCE_DIR} *.c)
  set_source_files_properties(${C_FILES} PROPERTIES LANGUAGE CXX
    COMPILE_FLAGS -fpermissive) # to allow some nonconforming code to compile
  # set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE CXX)
  # We require C++ 11. PUBLIC to propagate to numerics.
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.8.0")
    target_compile_features(externals PUBLIC cxx_std_11)
  else()
    set_property(TARGET externals PROPERTY CXX_STANDARD 11)
  endif()
else()
  # set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE C)
  if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    target_compile_features(externals PUBLIC c_std_11)
  else()
    set_property(TARGET externals PROPERTY C_STANDARD 11)
  endif()
endif()

# externals lib needs blas while tests need Blas AND lapack.
# Link only at build time.
target_link_libraries(externals PUBLIC $<BUILD_INTERFACE:BLAS::BLAS>)
target_include_directories(externals PRIVATE blas_lapack)
#target_include_directories(externals PRIVATE ${BLAS_INCLUDE_DIR})

get_target_property(CHECK BLAS::BLAS INTERFACE_INCLUDE_DIRECTORIES)
message("JZIEIEZIUZEIZEU ${CHECK}")

# We don't want warnings from externals libraries.
get_target_property(externals_COMPILE_FLAGS externals COMPILE_OPTIONS)
list(REMOVE_ITEM externals_COMPILE_FLAGS -Wall)
set_target_properties(externals PROPERTIES COMPILE_OPTIONS "${externals_COMPILE_FLAGS}")
target_compile_options(externals PRIVATE "-w")
target_compile_options(externals PRIVATE "-Wno-unused-variable")
target_compile_options(externals PRIVATE "-Wno-unused-parameter")
# An awful command asking to add fallow-argument-mismatch' option to compile fortran when compiler version is 10 or greater
# See https://scivision.co/gfortran-type-mismatch-error/
target_compile_options(externals PRIVATE $<$<AND:$<VERSION_GREATER_EQUAL:${CMAKE_Fortran_COMPILER_VERSION},10>,$<COMPILE_LANGUAGE:Fortran>>:-fallow-argument-mismatch>)

# - Extras, optional -
# --- SuiteSparse ---
# It is allowed to switch between system or local suitesparse,
# depending on the chosen user option.
# 'local' : use WITH_SYSTEM_SUITESPARSE=OFF, 'system' WITH_SYSTEM_SUITESPARSE=ON (default).
# For 'local' suite sparse, some extra setup is required in externals,
# while system suitesparse is searched for and configured
# during numerics component setup.
if(NOT WITH_SYSTEM_SUITESPARSE)
  include(suite_sparse_setup)
endif()


# ---- Installation ----
# Call siconos_component_install_setup(<COMPONENT>)
# to prepare installation of the current target.
# Before, it's necessary to set:
# 
# - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
#    that contain headers files that must be installed.
# 
# common install
# No headers installed for externals.
set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES)
# set(${COMPONENT}_HDRS_EXCLUDE tools/SiconosCompat.h)
siconos_component_install_setup(${COMPONENT})

# - Optional OCE Renderer setup (install only) -
if(WITH_OCE)
  include(oce_renderer)
endif()

if(WITH_SERIALIZATION AND INSTALL_EXTERNAL_HEADERS AND NOT WITH_SYSTEM_BOOST_SERIALIZATION)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_load_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_save_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_map.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_set.hpp
    DESTINATION include/siconos/boost/serialization)
endif()

# --- tests ---
include(${COMPONENT}_tests.cmake)


# # List of directories of headers not to be installed
# set(${COMPONENT}_HDRS_EXCLUDE_DIR PATH_SDK/include SOL/lumod-c)
# if(NOT INSTALL_EXTERNAL_HEADERS)
#   list(APPEND ${COMPONENT}_HDRS_EXCLUDE_DIR
#     blas_lapack
#     hairer
#     netlib/dftemplates
#     netlib/odepack
#     optim_misc
#     optim_misc/ql0001
#     sort
#     boost_contribs
#     tools)
# endif()

# # List of specific headers not to be installed
# set(${COMPONENT}_HDRS_EXCLUDE tools/SiconosCompat.h)

=== io/CMakeLists.txt ===
#================================================================
# cmake utilities to build IO component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time

# Component name (i.e. target name)
set(COMPONENT io)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
# Path must be relative to component path (i.e. to CMAKE_CURRENT_SOURCE_DIR)
set(${COMPONENT}_DIRS)

# By default this component has no sources, everything is optional :
# - serialization/generation part : sources in serialization and generation
# - mechanicsIO : sources in mechanics 

if(HAVE_SICONOS_MECHANICS)
  list(APPEND ${COMPONENT}_DIRS src/mechanics) 
endif()

# --- Serialization setup ---

if(WITH_SERIALIZATION)
  list(APPEND ${COMPONENT}_DIRS src/serialization)
  
  if(NOT WITH_GENERATION)
    # in that case, we use headers in src/generation.
    # Warning : they must regularly updated (build siconos with generation ON!)
    # to take into account all changes in siconos interface.
    # --- Some headers are generated in current binary dir ---
    list(APPEND ${COMPONENT}_DIRS src/generation)
  else()
    set(GENERATED_HEADER ${CMAKE_CURRENT_BINARY_DIR}/SiconosFullGenerated.hpp)
    set(GENERATED_HEADER_KERNEL ${CMAKE_CURRENT_BINARY_DIR}/SiconosFullKernelGenerated.hpp)

    # list components 'targeted' by generation
    set(io_targets ${COMPONENTS})
    list(REMOVE_ITEM io_targets numerics io externals)
    string(REPLACE ";" "," io_targets_list "${io_targets}")
    set(GENERATED_TARGETS --targets=${io_targets_list})

    if(HAVE_SICONOS_KERNEL)
      list(APPEND GENERATED_DEPENDENCIES ${CMAKE_SOURCE_DIR}/kernel/src/SiconosKernel.hpp)
    endif()
    if(HAVE_SICONOS_MECHANICS)
      list(APPEND GENERATED_DEPENDENCIES ${CMAKE_SOURCE_DIR}/mechanics/src/collision/native/SpaceFilter.hpp)
    endif()
    if(HAVE_SICONOS_CONTROL)
      list(APPEND GENERATED_DEPENDENCIES ${CMAKE_SOURCE_DIR}/control/src/SiconosControl.hpp)
    endif()
    list(APPEND GENERATED_INCLUDES -I${CMAKE_BINARY_DIR}) # For SiconosConfig.h
    if(SuiteSparse_CXSparse_INCLUDE_DIR)
      list(APPEND GENERATED_INCLUDES -I${SuiteSparse_CXSparse_INCLUDE_DIR})
    endif()
    
    if(MPI_FOUND)
      foreach(_DIR IN LISTS MPI_CXX_INCLUDE_PATH)
        list(APPEND GENERATED_INCLUDES -I${_DIR})
      endforeach()
    endif()

    set(GENERATED_COMMAND COMMAND ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      ${GENERATED_TARGETS} ${GENERATED_INCLUDES} --output=${GENERATED_HEADER}
      --source="${CMAKE_CURRENT_SOURCE_DIR}/../" --build="${CMAKE_BINARY_DIR}")

		## CMake >= 3.12
    # set(io_targets_doxy2xml "${io_targets}")
    # list(TRANSFORM io_targets_doxy2xml APPEND "-doxy2xml")
    set(io_targets_doxy2xml)
		foreach(_T IN LISTS io_targets)
			list(APPEND io_targets_doxy2xml "${_T}-doxy2xml")
		endforeach()

    add_custom_command(
      OUTPUT ${GENERATED_HEADER}
      DEPENDS ${io_targets_doxy2xml} ${GENERATED_DEPENDENCIES}
      ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      ${CMAKE_SOURCE_DIR}/io/tools/builder_common.py
      ${GENERATED_COMMAND})

    SET(GENERATED_COMMAND_KERNEL COMMAND ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      --targets=kernel ${GENERATED_INCLUDES}
      --output=${GENERATED_HEADER_KERNEL}
      --source="${CMAKE_CURRENT_SOURCE_DIR}/../" --build="${CMAKE_BINARY_DIR}")

    ADD_CUSTOM_COMMAND(
      OUTPUT ${GENERATED_HEADER_KERNEL}
      DEPENDS kernel-doxy2xml ${GENERATED_DEPENDENCIES}
      ${GENERATED_COMMAND_KERNEL})
  endif()
endif()

# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
# set(${COMPONENT}_EXCLUDE_DOXY)

# ------ include interface ------
# What is needed at build time
# by other targets to compile with current component.
# 
# It means that a call to
#  target_link_libraries(truc PRIVATE io)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
#
# If all dirs are required, just set
# set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES ${${COMPONENT}_DIRS})
# set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES ${${COMPONENT}_DIRS})

# ---- Final setup for the library ----
if(io_DIRS) # the component may be empty if mechanics and serialization are off
  include(ComponentSetup)
  create_siconos_component(${COMPONENT})
  
  # --- Extra setup for the component ---
  # Right now boost::serialization does some nasty things... so we have to
  # disable some undefined behavior checks ...
  if(USE_SANITIZER MATCHES "asan")
    target_compile_options(io PRIVATE "-fno-sanitize=vptr")
    target_compile_options(io PRIVATE "-fno-sanitize=alignment")
    target_compile_options(io PRIVATE "-fno-sanitize=null")
  endif()
  
  if(WITH_GENERATION)
    # add dependencies for header generation
    add_custom_target(SerializersGeneration ALL
      DEPENDS ${GENERATED_HEADER} ${GENERATED_HEADER_KERNEL})
    add_dependencies(_kernel SerializersGeneration)
    add_dependencies(${COMPONENT} SerializersGeneration)
  endif()
  
  # Links with other Siconos components
  
  if (CMAKE_SKIP_RPATH)
    # if no RPATH, then linking does not work for tests without specifying externals
    target_link_libraries(io PRIVATE externals)
  endif()
  
  target_link_libraries(io PRIVATE numerics)
  target_link_libraries(io PUBLIC kernel)
  
  if(HAVE_SICONOS_CONTROL)
    target_link_libraries(io PRIVATE control)
  endif()
  
  if(HAVE_SICONOS_MECHANICS)
    target_link_libraries(io PUBLIC mechanics)
  endif()
  
  if(HAVE_SICONOS_MECHANISMS)
    # FP : do we really need this link?
    target_link_libraries(io PUBLIC mechanisms)
  endif()

  # Links with non-Siconos libraries
  if(SICONOS_HAS_OCE)
    if(HAVE_SICONOS_MECHANICS OR HAVE_SICONOS_MECHANISMS)
      target_link_libraries(io PRIVATE ${OCE_LIBRARIES})
    endif()
  endif()
  
  # --- Search component dependencies ---
  if(WITH_SERIALIZATION)
    # boost must have been searched for in SiconosSetup ...
    target_link_libraries(io PUBLIC Boost::boost Boost::serialization Boost::filesystem)
    # TEST_SERIALIZATION_VECTOR_BUG() : not needed anymore, since we required boost >= 1.61
    # These test macros have been moved to siconos-junk.

    target_include_directories(io PRIVATE serialization)
    if(NOT WITH_GENERATION)
      target_include_directories(io PRIVATE generation)
    else()
      target_include_directories(io PRIVATE ${CMAKE_BINARY_DIR}/io)
    endif()
  endif()
  
  if(WITH_VTK)
    # https://cmake.org/cmake/help/latest/module/FindVTK.html
    find_package(VTK )
    target_link_libraries(io PRIVATE vtkIO;vtkCommon;vtkGraphics;vtkRendering)
  endif()

  # --- python bindings ---
  if(WITH_${COMPONENT}_PYTHON_WRAPPER)
    add_subdirectory(swig)
  endif()
  
  if(WITH_PYTHON_WRAPPER)
    add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
  endif()
  
  # ---- Installation ----
  # Call siconos_component_install_setup(<COMPONENT>)
  # to prepare installation of the current target.
  #
  # Before, it's necessary to set:
  # 
  # - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
  #    that contain headers files that must be installed.
  # 
  # set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES)
  if(WITH_SERIALIZATION)
    list(APPEND ${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES src/serialization)
    if(NOT WITH_GENERATION)
      list(APPEND ${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES src/generation)
    endif()
  endif()
  
  if(HAVE_SICONOS_MECHANICS)
    list(APPEND ${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES src/mechanics)
  endif()
  siconos_component_install_setup(${COMPONENT})
  
  # --- tests ---
  include(${COMPONENT}_tests.cmake)
endif()

=== mechanisms/CMakeLists.txt ===
#================================================================
# cmake utilities to build mechanisms component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time

set(COMPONENT mechanisms)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
# Path must be relative to component path (i.e. to CMAKE_CURRENT_SOURCE_DIR)

set(${COMPONENT}_DIRS
  src/.
  src/CADMBTB
  src/MBTB
  src/TIMERMBTB)


# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
# set(${COMPONENT}_EXCLUDE_DOXY)

# ------ include interface ------
# What is needed at build time
# by other targets to compile with current component.
# 
# It means that a call to
#  target_link_libraries(truc PRIVATE mechanics)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES ${${COMPONENT}_DIRS})
  
# -- create/setup component target --
include(ComponentSetup)
create_siconos_component(${COMPONENT})

# --- Extra setup for the component ---

# Links with other Siconos components
target_link_libraries(mechanisms PUBLIC
  externals
  numerics 
  kernel
  mechanics)

# Links with non-Siconos libraries
# --- Search component dependencies ---
if(NOT WITH_OCE)
  message(FATAL_ERROR "Please run cmake again with option WITH_OCE=ON (required for mechanisms) or do not setup Siconos with mechanisms component.")
endif()
# Add oce headers and libs to component build.
target_link_libraries(${COMPONENT} PUBLIC $<BUILD_INTERFACE:OCE::OCE>)

# --- python bindings ---
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  add_subdirectory(swig)
endif()

if(WITH_PYTHON_WRAPPER)
  add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
endif()  

# ---- Installation ----
# Call siconos_component_install_setup(<COMPONENT>)
# to prepare installation of the current target.
#
# Before, it's necessary to set:
# 
# - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
#    that contain headers files that must be installed.
# 
set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES
  ${${COMPONENT}_DIRS} # All .hpp are installed
  )

siconos_component_install_setup(${COMPONENT})

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== numerics/CMakeLists.txt ===
#================================================================
# cmake utilities to build numerics component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time

# Component name (i.e. target name)
set(COMPONENT numerics)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
# Path must be relative to component path (i.e. to CMAKE_CURRENT_SOURCE_DIR)
set(${COMPONENT}_DIRS
  src/.
  src/tools
  src/tools/InterfaceToPathFerris
  src/tools/internal
  src/AVI
  src/LCP
  src/MLCP
  src/SOCP
  src/QP
  src/Relay
  src/FrictionContact
  src/FrictionContact/Generated
  src/NCP
  src/MCP
  src/GenericMechanical
  src/VI
)

# - Extras, optional -
# Static verifications (ACSL)
if(WITH_FRAMA_C)
  include(FramaC)
  file(GLOB frama_c_files src/FrictionContact/Generated/*.c)
  foreach(f ${frama_c_files})
    add_frama_c_test(${f} ENTRY main)
  endforeach()
  add_frama_c_test(${CMAKE_CURRENT_SOURCE_DIR}/src/tools/test/test_static_op3x3.c ENTRY main INCLUDES ${CMAKE_SOURCE_DIR}/externals/tools)
endif()

# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
set(${COMPONENT}_EXCLUDE_DOXY src/Unstable_or_deprecated)

# ------ include interface ------
# What is needed at build time
# by other targets to compile with current component.
# 
# It means that a call to
#  target_link_libraries(truc PRIVATE numerics)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES
  src
  src/tools
  src/tools/InterfaceToPathFerris
  src/tools/internal
  src/AVI
  src/LCP
  src/MLCP
  src/SOCP
  src/QP
  src/Relay
  src/FrictionContact
  src/FrictionContact/Generated
  src/NCP
  src/MCP
  src/GenericMechanical
  src/VI
  )

# ---- Final setup for the library ----

# Windows stuff
include(WindowsNumericsSetup)

# -- create/setup component target --
include(ComponentSetup)
create_siconos_component(${COMPONENT})

# --- Extra setup for the component ---
if(MLCPSIMPLEX_FOUND OR BUILD_AS_CPP) 
  set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE CXX)
  file(GLOB_RECURSE C_FILES ${CMAKE_CURRENT_SOURCE_DIR} *.c)
  set_source_files_properties(${C_FILES} PROPERTIES LANGUAGE CXX)
else()
  set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE C)
endif()

# Links with other Siconos components
target_link_libraries(numerics PRIVATE externals)

# Links with non-Siconos libraries

# Blas/Lapack from externals
target_include_directories(numerics PRIVATE $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>/externals/blas_lapack)
target_link_libraries(numerics PUBLIC $<BUILD_INTERFACE:LAPACK::LAPACK>)
#target_link_libraries(numerics INTERFACE LAPACK::LAPACK)

if(CMAKE_DL_LIBS)
  # CMAKE_DL_LIBS needed for dlopen or equivalent
  target_link_libraries(numerics PRIVATE ${CMAKE_DL_LIBS})
endif()

# -- Optional deps --

# Always searched and activated if found :
#    lpsolve, mlcpsimplex, pthread, path (Ferris and VI)
# Searched if asked in config (WITH_...=TRUE), error if not found :
#    fclib, suite-sparse, gams

# - LpSolve -
find_package(LPSOLVE QUIET)
if(LPSOLVE_FOUND)
  # to add more tests in numerics
  set(HAS_ONE_LP_SOLVER TRUE CACHE INTERNAL "True if a LP Solver has been found and is activated.")
  # to add more tests in kernel and control
  set(HAS_EXTREME_POINT_ALGO TRUE CACHE INTERNAL "True if lpsolve has been found and is activated.")
  target_link_libraries(numerics PRIVATE LPSOLVE::LPSOLVE)
endif()

# - Thread -
# If Pthread is to be chosen in any case, set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
# https://cmake.org/cmake/help/v3.7/module/FindThreads.html?highlight=pthread
if(Threads_FOUND)
  target_link_libraries(numerics PRIVATE Threads::Threads)
endif()

# - Fclib - 
if(WITH_FCLIB)
  find_package(FCLIB 3.0.0 CONFIG REQUIRED)
  if(FCLIB_NOT_FOUND)
    message(FATAL_ERROR "Can not find fclib package. Try to set FCLIB_ROOT.")
  endif()
  target_link_libraries(numerics PUBLIC FCLIB::fclib)
endif()

# - SuiteSparse -
# numerics possibly needs suite sparse installed on the system.
# -- Check size_t value --> choice of CSparse/CXSparse integer size
if(NOT DEFINED SICONOS_INT64)
  if(NOT SIZE_OF_CSI)
    include(CheckTypeSize)
    check_type_size("size_t" SIZE_OF_CSI)
    if(NOT SIZE_OF_CSI) # This won't happen with c11
      message(FATAL_ERROR
        "Could not get size of size_t, please specify SICONOS_INT64.")
    endif()
  endif()

  if("${SIZE_OF_CSI}" EQUAL 8)
    set(SICONOS_INT64 TRUE CACHE INTERNAL "")
  else()
    set(SICONOS_INT64 FALSE CACHE INTERNAL "")
  endif()
endif()

if(WITH_SYSTEM_SUITESPARSE)
  #   Note : the CSparse data structures are referred to in
  #   kernel, but the functions are only called from numerics, so it is
  #   not a link-time dependency for kernel.
  find_package(SuiteSparse COMPONENTS CXSparse REQUIRED)
  # We should turn public to private later (?)
  # SuiteSparse headers are required by kernel
  target_link_libraries(numerics PUBLIC $<BUILD_INTERFACE:SuiteSparse::CXSparse>)
  target_include_directories(numerics PUBLIC $<INSTALL_INTERFACE:${SuiteSparse_CXSparse_INCLUDE_DIR}>)
endif()

# - MLCP Simplex -
find_package(MlcpSimplex QUIET)
if(MlcpSimplex_FOUND)
  set(HAVE_MLCPSIMPLEX TRUE CACHE INTERNAL "True if mlcp simplex solver API has been found and is activated.")
  target_link_libraries(numerics PRIVATE $<BUILD_INTERFACE:MlcpSimplex::MlcpSimplex>)
endif()

# - GAMS, Path -
# Checks GAMS, Path (Ferris, VI). See details in gams_path_setup.cmake file.
include(gams_path_setup)

# - UMFPack -
if(WITH_UMFPACK)
  find_package(UMFPACK REQUIRED)
  target_link_libraries(numerics PUBLIC UMFPACK::UMFPACK)
endif()

# - SuperLU -

# Serial version
if(WITH_SUPERLU)
  find_package(SuperLU REQUIRED)
endif()
# Multithreaded version
if(WITH_SUPERLU_MT)
  find_package(SuperLU_MT REQUIRED COMPONENTS MT)
endif()
# MPI/OpenMP version
if(WITH_SUPERLU_DIST)
  find_package(SuperLU_MT REQUIRED COMPONENTS DIST)
endif()
if(SuperLU_FOUND)
  
  target_link_libraries(numerics PRIVATE SuperLU::SuperLU)
endif()

# mumps and mpi
if(WITH_MPI)
  target_include_directories(numerics PUBLIC ${MPI_C_INCLUDE_DIRS})
  # Note FP : PUBLIC for the moment since it's required by tests.
  # This will be improved later.
  target_link_libraries(numerics PUBLIC ${MPI_C_LIBRARIES})
  #   target_include_directories(numerics PRIVATE ${MPI_Fortran_INCLUDE_DIRS})
  #   target_link_libraries(numerics PRIVATE ${MPI_Fortran_LIBRARIES})
endif()

if(WITH_MUMPS)
  if(WITH_MPI)
    find_package(MUMPS REQUIRED COMPONENTS PAR)
  else()
    find_package(MUMPS REQUIRED COMPONENTS SEQ)
  endif()
  target_link_libraries(numerics PRIVATE MUMPS::MUMPS)
endif()

# -- HDF5 --
# For logging
if(WITH_HDF5)
  find_package(HDF5 REQUIRED COMPONENTS C HL)
  target_include_directories(${PROJECT_NAME} PRIVATE ${HDF5_C_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} PRIVATE ${HDF5_C_LIBRARIES})
  target_link_libraries(${PROJECT_NAME} PRIVATE ${HDF5_HL_LIBRARIES})
endif()

# -- OpenMP --
if(WITH_OPENMP)
  find_package(OpenMP REQUIRED)
  # Notice : cmake  >= 3.9.6 is advised for a proper handling of openmp
  if(${CMAKE_VERSION} VERSION_GREATER "3.9.6")
    target_link_libraries(numerics  PRIVATE OpenMP::OpenMP_C)
    target_link_libraries(numerics  PRIVATE OpenMP::OpenMP_CXX)
  else()
    message("Openmp flags : ${OpenMP_C_FLAGS}")
    target_compile_options(numerics PRIVATE  ${OpenMP_C_FLAGS})
  endif()
endif()

# --- python bindings ---
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  add_subdirectory(swig)
endif()

if(WITH_PYTHON_WRAPPER)
  add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
endif()  

# ---- Installation ----
# Call siconos_component_install_setup(<COMPONENT>)
# to prepare installation of the current target.
#
# Before, it's necessary to set:
# 
# - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
#    that contain headers files that must be installed.
# 
set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES
  src
  src/tools
  #   src/tools/internal
  src/AVI
  src/LCP
  src/MCP
  src/MLCP
  src/Relay
  src/FrictionContact
  # src/FrictionContact/Generated
  # src/GenericMechanical
  )

# List header files (in dir above) that must not be installed 
set(${COMPONENT}_HDRS_EXCLUDE src/FrictionContact/Generated/funcodegen.h)

siconos_component_install_setup(${COMPONENT})

# --- tests ---
include(${COMPONENT}_tests.cmake)

if(WITH_MPI AND WITH_${COMPONENT}_TESTING)
  # Note FP : temporary fix, to deal with PRIVATE deps of some components.
  # This will be reviewed later.
  target_include_directories(numerics-test PUBLIC ${MPI_C_INCLUDE_DIRS})
  target_link_libraries(numerics-test PUBLIC ${MPI_C_LIBRARIES})
endif()

=== wrap/CMakeLists.txt ===
# ============================================================
# Prepare swig config to generate python bindings for siconos
# ============================================================
if(WITH_PYTHON_WRAPPER)
  # Name of the generated Python package
  set(SICONOS_PYTHON_PACKAGE ${PROJECT_NAME} CACHE INTERNAL "Name of the Siconos python package.")
  
  # --------------- Python install setup ---------------
  # Set path for siconos-python installation
  include(PythonInstallSetup)
  set_python_install_path()
  
  #  ----------- swig -----------

  # -- Swig  preprocessor def. common to all swig targets --
  # --> SWIG_DEFS
  # get system architecture 
  # https://raw.github.com/petroules/solar-cmake/master/TargetArch.cmake
  include(TargetArch)
  target_architecture(SYSTEM_ARCHITECTURE)
  if(WITH_SYSTEM_INFO) # User defined option, default = off
    include(CMakePrintSystemInformation)
    message(STATUS "SYSTEM ARCHITECTURE: ${SYSTEM_ARCHITECTURE}")
  endif()
  if(SYSTEM_ARCHITECTURE)
    list(APPEND CMAKE_SWIG_FLAGS "-D__${SYSTEM_ARCHITECTURE}__")
  endif()

  list(APPEND CMAKE_SWIG_FLAGS "-py3")

  list(REMOVE_DUPLICATES CMAKE_SWIG_FLAGS)
  set(CMAKE_SWIG_FLAGS "${CMAKE_SWIG_FLAGS}" CACHE INTERNAL "Swig flags")

  # -dirvtable      - Generate a pseudo virtual table for directors for faster dispatch
  # - without "dirprot", swig wrap public methods and only the 
  # protected methods needed to the interface to compile.
  # - with "dirprot" swig will attemp to wrap all the public and protected methods at once.
  set(SWIG_DEFS "-dirprot;-dirvtable;-Wextra")

  if(WITH_FCLIB)
    set(SWIG_DEFS "${SWIG_DEFS};-DWITH_FCLIB")
  endif()
  
  if(HAVE_SICONOS_IO)
    set(SWIG_DEFS "${SWIG_DEFS};-DWITH_IO")
    if(WITH_SERIALIZATION)
      set(SWIG_DEFS "${SWIG_DEFS};-DWITH_SERIALIZATION")
    endif()
  endif()
  # -- Swig files --
  # Path to .i files, common to all modules and submodules.
  set(SICONOS_SWIG_SRC_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/swig
    CACHE INTERNAL "Path to swig files common to all packages.")

  # -- Output dir for python generated packages --
  set(SICONOS_SWIG_ROOT_DIR ${CMAKE_CURRENT_BINARY_DIR}/${SICONOS_PYTHON_PACKAGE}
    CACHE INTERNAL "Root path for swig outputs.")

  # -- include dir --
  set(SICONOS_SWIG_INCLUDE_DIRS ${SICONOS_SWIG_SRC_DIRS} ${SICONOS_SWIG_ROOT_DIR} ${Python3_INCLUDE_DIRS}
    CACHE INTERNAL "Directories required for swig includes.")

  foreach(_dir ${SICONOS_SWIG_INCLUDE_DIRS})
    set(SWIG_DEFS "-I${_dir};${SWIG_DEFS}")
  endforeach()

  set(SWIG_DEFS "${SWIG_DEFS}" CACHE INTERNAL "Swig extra definitions.")

  include_directories(${SICONOS_SWIG_INCLUDE_DIRS})

  # ------------- Tests -------------
  if(WITH_TESTING)
    IF(CROSSCOMPILING_LINUX_TO_WINDOWS)
      SET(EMULATOR "wine")
      SET(DRIVE_LETTER "Z:")
    ELSE()
      SET(EMULATOR)
      SET(DRIVE_LETTER)
    ENDIF()

    # if a (DY)LD_LIBRARY_PATH is needed, export it
    set(EXPORT_LDLIBPATH)
    include(tools4tests)
    set_ldlibpath()
    if(LDLIBPATH)
      # put quotes around the paths for export
      string(REPLACE "=" ";" ENV_LDLIBPATH "${LDLIBPATH}")
      list(GET ENV_LDLIBPATH 0 ENV_LDLIBPATH_NAME)
      list(GET ENV_LDLIBPATH 1 ENV_LDLIBPATH_PATH)
      set(EXPORT_LDLIBPATH "export ${ENV_LDLIBPATH_NAME}=\"${ENV_LDLIBPATH_PATH}\"")
    endif()

    # -- test config--
    file(MAKE_DIRECTORY ${SICONOS_SWIG_ROOT_DIR}/tests)
    configure_file(tests_setup.py.in ${SICONOS_SWIG_ROOT_DIR}/tests_setup.py)
    configure_file(set_tests_env.sh.in set_tests_env.sh)
    configure_file(utils/__init__.py ${SICONOS_SWIG_ROOT_DIR}/tests/__init__.py)
    add_custom_target(set_envtest numerics
      COMMAND sh ${CMAKE_CURRENT_BINARY_DIR}/set_tests_env.sh
      COMMENT "set environment variables for python tests ...")
    # todo if we need to add some 'global' tests for siconos (not component dependent)
    # create a wrap/swig/tests dir and ...
  endif()

  # ====== Generates python files required for build/install process ======

  # setup.py --> CMAKE_BINARY_DIR
  if(EXISTS  ${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in)
    message(STATUS "Generate setup.py file ...")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in setup.py)
  endif()

  # The file __init__.py will be generated from __init__.py.in.
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in)
    message(STATUS "Generate __init__.py file ...")
    if(EXISTS ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
      file(REMOVE ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
    endif()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
  endif()

  # Some python files, that do not depend on siconos
  # but may be useful ...
  file(GLOB pyfiles ${CMAKE_CURRENT_SOURCE_DIR}/utils/[^_]*.py)
  foreach(_file ${pyfiles})
    get_filename_component(_filename ${_file} NAME)
    configure_file(utils/${_filename} ${SICONOS_SWIG_ROOT_DIR}/${_filename} COPYONLY)
  endforeach()

  # ====== Create (and setup) build target ======

  add_custom_target(python-build
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py build
    COMMENT "Build ${SICONOS_PYTHON_PACKAGE} package")
  
  if(UNIX AND NOT APPLE)
    list(APPEND python_install_options "--root=$(DESTDIR)/")
  endif()
  add_custom_target(python-install
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py install ${python_install_options}
    VERBATIM
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMENT "build/install siconos package")
  install(CODE "execute_process(COMMAND ${CMAKE_BUILD_TOOL} python-install WORKING_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}\")")

  # ====== Create a Target to clean sources (remove .pyc files) and build dir ======

  file(GLOB_RECURSE PYCFILES "${CMAKE_SOURCE_DIR}/*.pyc")
  add_custom_target(pyclean COMMAND rm -f ${PYCFILES}
    COMMAND make clean
    COMMAND rm -rf ${CMAKE_BINARY_DIR}/build
    COMMENT "Clean sources and build.")

  # ====== conf/copy file for docstrings generation from doxygen ====

endif()

=== externals/swig/CMakeLists.txt ===
#================================================================
# cmake utilities to build python-bindings for externals component
#================================================================

# wrap - Set extra dependencies
set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS
  ${SICONOS_SWIG_SRC_DIRS}/KernelTypes.i
  ${SICONOS_SWIG_SRC_DIRS}/solverOptions.i
  ${SICONOS_SWIG_SRC_DIRS}/start.i
  ${SICONOS_SWIG_SRC_DIRS}/end.i
  ${SICONOS_SWIG_SRC_DIRS}/numpy.i
  ${SICONOS_SWIG_SRC_DIRS}/pyRegister.i)

# List of modules to be built in the python bindings
set(${COMPONENT}_PYTHON_MODULES "./${COMPONENT}")

set(${COMPONENT}_SWIG_INCLUDE_DIRECTORIES)
set(${COMPONENT}_SWIG_DEFS "${SWIG_DEFS}")

include(swig_python_tools)

#swig_module_setup(${COMPONENT}_PYTHON_MODULES)

#build_python_tests()

=== io/swig/CMakeLists.txt ===
#================================================================
# cmake utilities to build python-bindings for io component
#================================================================

# wrap - Set extra dependencies
set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS)

# List of modules to be built in the python bindings
set(${COMPONENT}_PYTHON_MODULES "io/io_base")

set(${COMPONENT}_SWIG_INCLUDE_DIRECTORIES)

set(${COMPONENT}_SWIG_DEFS "${SWIG_DEFS}")

list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES ${CMAKE_SOURCE_DIR}/kernel/swig)
if(HAVE_SICONOS_MECHANICS)
  list(APPEND ${COMPONENT}_SWIG_DEFS "-DWITH_MECHANICS")

  if(INSTALL_PYTHON_SYMLINKS)
    message("Making symlinks for io Python modules")
    execute_process(COMMAND sh -c "mkdir -p '${SICONOS_SWIG_ROOT_DIR}/io'")
    execute_process(COMMAND sh -c "test -e '${SICONOS_SWIG_ROOT_DIR}/io/mechanics_hdf5.py' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/mechanics_hdf5.py' '${SICONOS_SWIG_ROOT_DIR}/io/mechanics_hdf5.py'")
    execute_process(COMMAND sh -c "test -e '${SICONOS_SWIG_ROOT_DIR}/io/mechanics_run.py' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/mechanics_run.py' '${SICONOS_SWIG_ROOT_DIR}/io/mechanics_run.py'")
    execute_process(COMMAND sh -c "test -e '${SICONOS_SWIG_ROOT_DIR}/io/FrictionContactTrace.py' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/FrictionContactTrace.py' ${SICONOS_SWIG_ROOT_DIR}/io/FrictionContactTrace.py")
    execute_process(COMMAND sh -c "test -e '${SICONOS_SWIG_ROOT_DIR}/io/vview.py' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/vview.py' ${SICONOS_SWIG_ROOT_DIR}/io/vview.py")

    message("Setting up symlink install targets for io Python executables")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_vview' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/siconos_vview.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_vview' \")")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_vexport' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/siconos_vexport.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_vexport'\")")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_export_raw_data' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/siconos_export_export_raw_data.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_export_raw_data'\")")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_info' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/info.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_info'\")")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_filter' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/filter.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_filter'\")")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_run' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/io/run.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_run'\")")
  else()

    configure_file(io/mechanics_hdf5.py ${SICONOS_SWIG_ROOT_DIR}/io/mechanics_hdf5.py @ONLY)
    configure_file(io/mechanics_run.py ${SICONOS_SWIG_ROOT_DIR}/io/mechanics_run.py @ONLY)
    configure_file(io/FrictionContactTrace.py ${SICONOS_SWIG_ROOT_DIR}/io/FrictionContactTrace.py @ONLY)
    configure_file(io/vview.py      ${SICONOS_SWIG_ROOT_DIR}/io/vview.py @ONLY)

    configure_file(io/siconos_vview.py ${SICONOS_SWIG_ROOT_DIR}/io/siconos_vview @ONLY)
    configure_file(io/siconos_vexport.py ${SICONOS_SWIG_ROOT_DIR}/io/siconos_vexport @ONLY)
    configure_file(io/siconos_export_raw_data.py ${SICONOS_SWIG_ROOT_DIR}/io/siconos_export_raw_data @ONLY)
    configure_file(io/info.py       ${SICONOS_SWIG_ROOT_DIR}/io/siconos_info @ONLY)
    configure_file(io/filter.py     ${SICONOS_SWIG_ROOT_DIR}/io/siconos_filter @ONLY)
    configure_file(io/run.py        ${SICONOS_SWIG_ROOT_DIR}/io/siconos_run @ONLY)
    configure_file(io/compare.py    ${SICONOS_SWIG_ROOT_DIR}/io/siconos_compare @ONLY)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_vview    DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_vexport  DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_export_raw_data  DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_info     DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_filter   DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_run      DESTINATION bin)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_compare  DESTINATION bin)
    # automatic manpages using help2man

    # See if help2man is available
    find_program(HELP2MAN help2man)
    if (HELP2MAN)
      # all other components must be built first so that tools don't fail to run
      set(_OTHER_COMPONENTS ${COMPONENTS})
      list(REMOVE_ITEM _OTHER_COMPONENTS ${COMPONENT})

      # swig modules must be built before vview and vexport can generate manpages
      foreach(_SWIG_MODULE ${${COMPONENT}_PYTHON_MODULES})
        get_filename_component(_SWIG_MODULE_NAME ${_SWIG_MODULE} NAME)
        list(APPEND _OTHER_COMPONENTS ${_SWIG_MODULE_NAME}_swig_compilation _${_SWIG_MODULE_NAME})
      endforeach()

      set(MANPAGES_FOR_TOOLS)
      include(tools4tests)
      set_ldlibpath()
      macro (GEN_MANPAGE_FROM_HELP TOOL)
        # set PYTHONPATH to swig dir, which contains "siconos", so
        # that "import siconos.*" works
        add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/man/${TOOL}.1
          COMMAND env PYTHONPATH=${SICONOS_SWIG_ROOT_DIR}/.. ${LDLIBPATH}
            ${HELP2MAN} -s1 -N -o  ${CMAKE_BINARY_DIR}/man/${TOOL}.1
            --opt-include=${CMAKE_SOURCE_DIR}/man/${TOOL}.help2man
            --include=${CMAKE_SOURCE_DIR}/man/footer.help2man
            --no-discard-stderr
            -n \"`sed '/Description: /!d\;s///' ${SICONOS_SWIG_ROOT_DIR}/io/${TOOL}`\"
            ${SICONOS_SWIG_ROOT_DIR}/io/${TOOL}
          DEPENDS ${SICONOS_SWIG_ROOT_DIR}/io/${TOOL} ${_OTHER_COMPONENTS}
          WORKING_DIRECTORY ${SICONOS_SWIG_ROOT_DIR}/..
          COMMENT "Generating man/${TOOL}.1 using help2man"
          )
        install(FILES ${CMAKE_BINARY_DIR}/man/${TOOL}.1 DESTINATION share/man/man1)
        list(APPEND MANPAGES_FOR_TOOLS ${CMAKE_BINARY_DIR}/man/${TOOL}.1)
      endmacro()
      list(FIND COMPONENTS mechanics _HAVE_MECHANICS)
      if (NOT ${_HAVE_MECHANICS} EQUAL -1)
        GEN_MANPAGE_FROM_HELP(siconos_vview)
        GEN_MANPAGE_FROM_HELP(siconos_vexport)
        GEN_MANPAGE_FROM_HELP(siconos_export_raw_data)
        GEN_MANPAGE_FROM_HELP(siconos_info)
        GEN_MANPAGE_FROM_HELP(siconos_run)
        GEN_MANPAGE_FROM_HELP(siconos_filter)
        GEN_MANPAGE_FROM_HELP(siconos_compare)
      endif()

      add_custom_target(manpages ALL DEPENDS ${MANPAGES_FOR_TOOLS})
    endif()
  endif()

endif()

if(HAVE_SICONOS_MECHANISMS)
  list(APPEND ${COMPONENT}_SWIG_DEFS "-DWITH_MECHANISMS")
  if(${CMAKE_VERSION} VERSION_LESS "3.13")
    list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/mechanisms/src/")
  endif()
  if(INSTALL_PYTHON_SYMLINKS)
    message("Making symlinks for io Python modules")
    execute_process(COMMAND sh -c "mkdir -p '${SICONOS_SWIG_ROOT_DIR}/io'")
    configure_file(io/pprocess.py   ${SICONOS_SWIG_ROOT_DIR}/io/siconos_pprocess @ONLY)
  else()
    configure_file(io/pprocess.py   ${SICONOS_SWIG_ROOT_DIR}/io/siconos_pprocess @ONLY)
    install(PROGRAMS ${SICONOS_SWIG_ROOT_DIR}/io/siconos_pprocess DESTINATION bin RENAME siconos_pprocess)
  endif()
endif()

# TMP fix 
if(${CMAKE_VERSION} VERSION_LESS "3.13")
  # Notice that with last cmake versions, it's possible to propagate includes to swig in a better way.
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/numerics/src/tools")
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIR}")
endif()




include(swig_python_tools)
swig_module_setup(${COMPONENT}_PYTHON_MODULES)

# right now the only tests we have require serialization
if(WITH_SERIALIZATION)
  if(WITH_${COMPONENT}_TESTING)
    build_python_tests(
      # DEPS ${COMPONENT} # some plugins in tests need to be linked with kernel
      )
  endif()
endif()

=== mechanics/swig/CMakeLists.txt ===
#================================================================
# cmake utilities to build python-bindings for mechanics component
#================================================================

# wrap - Set extra dependencies
set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS)

# DEFS
set(${COMPONENT}_SWIG_DEFS "${SWIG_DEFS}")

# List of modules to be built in the python bindings
set(${COMPONENT}_PYTHON_MODULES
  "mechanics/joints"
  "mechanics/collision/base"
  "mechanics/collision/native"
  "mechanics/collision/bodies")

list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES ${CMAKE_SOURCE_DIR}/kernel/swig)
# TMP fix 
if(${CMAKE_VERSION} VERSION_LESS "3.13")
  # Notice that with last cmake versions, it's possible to propagate includes to swig in a better way.
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/numerics/src/tools")
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIR}")
endif()

if(WITH_OCE)
  list(APPEND ${COMPONENT}_PYTHON_MODULES "mechanics/occ")
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
    set_property(SOURCE occ.i PROPERTY USE_TARGET_INCLUDE_DIRECTORIES ON)
  else() #USE_TARGET_INCLUDE property is not available in old cmake versions.
    list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${OCE_INCLUDE_DIRS}")
    list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/mechanics/src/occ")
  endif()
endif()

if(WITH_BULLET)
  list(APPEND ${COMPONENT}_PYTHON_MODULES "mechanics/collision/bullet")
  # list(APPEND ${COMPONENT}_SWIG_DEFS "-DWITH_BULLET") # Do we really need this??

  # ignore all warnings generated by Bullet headers since we can't
  # do anything about them and it clutters the output
  list(APPEND ${COMPONENT}_SWIG_DEFS_bullet
    "-w312,322,325,350,351,362,383,389,394,395,401,402,403,503,512,520")

  if(BULLET_USE_DOUBLE_PRECISION)
    list(APPEND ${COMPONENT}_SWIG_DEFS "-DBT_USE_DOUBLE_PRECISION")
  endif()

  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13")
    set_property(SOURCE bullet.i PROPERTY USE_TARGET_INCLUDE_DIRECTORIES ON)
  else() #USE_TARGET_INCLUDE property is not available in old cmake versions.
    list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${BULLET_INCLUDE_DIR}")
    list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/mechanics/src/collision/bullet")
  endif()

endif()


configure_file(mechanics/collision/tools.py ${SICONOS_SWIG_ROOT_DIR}/mechanics/collision/tools.py)
configure_file(mechanics/collision/convexhull.py  ${SICONOS_SWIG_ROOT_DIR}/mechanics/collision/convexhull.py )
configure_file(mechanics/collision/__init__.py  ${SICONOS_SWIG_ROOT_DIR}/mechanics/collision/__init__.py )
include(swig_python_tools)
swig_module_setup(${COMPONENT}_PYTHON_MODULES)

if(WITH_FREECAD)
  # -- FreeCAD --
  # For python bindings.
  find_package(FeedCAD COMPONENTS Part REQUIRED)
  #  FP : which swig module needs freecad? Is this part outdated? 
  # target_link_libraries(?? PRIVATE ${FreeCAD_LIBRARIES})
endif()


# --- Tests ---
if(WITH_${COMPONENT}_TESTING)
  if(NOT WITH_OCE)
    list(APPEND python_excluded_tests tests/test_occ_inertia.py)
  else()
    find_python_module(OCC REQUIRED)
  endif()
  build_python_tests(
    # DEPS ${COMPONENT} # some plugins in tests need to be linked with kernel
    EXCLUDE ${python_excluded_tests})
endif()

if(NOT NO_RUNTIME_BUILD_DEP)
  find_python_module(pyhull)
endif()

=== mechanisms/swig/CMakeLists.txt ===
#==================================================================
# cmake utilities to build python-bindings for mechanisms component
#==================================================================

# wrap - Set extra dependencies
set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS)

# DEFS
set(${COMPONENT}_SWIG_DEFS "${SWIG_DEFS}")

# List of modules to be built in the python bindings
set(${COMPONENT}_PYTHON_MODULES
  "mechanisms/cadmbtb"
  "mechanisms/mbtb")

list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES ${CMAKE_SOURCE_DIR}/kernel/swig)
# TMP fix 
if(${CMAKE_VERSION} VERSION_LESS "3.13")
  # Notice that with last cmake versions, it's possible to propagate includes to swig in a better way.
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/numerics/src/tools")
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${OCE_INCLUDE_DIRS}")
  list(APPEND ${COMPONENT}_SWIG_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIR}")
endif()

include(swig_python_tools)

swig_module_setup(${COMPONENT}_PYTHON_MODULES)

# we need siconos-mechanism for build and install tree with different 'PYTHONPATH' for each of them.


# -- install the script --
set(CURRENT_PYTHON_PATH ${SICONOS_PYTHON_INSTALL_DIR})
set(EXAMPLE_PATH ./) # @EXAMPLE_PATH@ is required in siconos_mechanisms script
configure_file(siconos_mechanisms.py.in ${CMAKE_BINARY_DIR}/scripts/siconos_mechanisms.py)
configure_file(mechanisms/mbtbDefaultOptions.py ${SICONOS_SWIG_ROOT_DIR}/mechanisms/mbtbDefaultOptions.py)
install(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/siconos_mechanisms.py DESTINATION bin RENAME siconos_mechanisms)


# --- Tests ---
if(WITH_${COMPONENT}_TESTING)
  # -- prepare siconos_mechanisms tests --
  set(CURRENT_PYTHON_PATH ${CMAKE_BINARY_DIR}/wrap)
  set(EXAMPLE_PATH ${SICONOS_SWIG_ROOT_DIR}/tests/) # @EXAMPLE_PATH@ is required in siconos_mechanisms script
  # Each file is copied into siconos/tests.
  configure_file(siconos_mechanisms.py.in  ${SICONOS_SWIG_ROOT_DIR}/tests/siconos_mechanisms.py)

  # data (CAD and body) taken from slider crank example in mechanisms component
  set(path_to_test_sources ${CMAKE_SOURCE_DIR}/mechanisms/swig/tests/slider_crank)
  configure_file(${path_to_test_sources}/bodydef.py ${SICONOS_SWIG_ROOT_DIR}/tests/ COPYONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tests/mbtbLocalOptions.py ${SICONOS_SWIG_ROOT_DIR}/tests/ COPYONLY)
  file(GLOB cad4tests RELATIVE ${path_to_test_sources}/CAD ${path_to_test_sources}/CAD/*)
  foreach(datafile ${cad4tests})
    configure_file(${path_to_test_sources}/CAD/${datafile}
      ${SICONOS_SWIG_ROOT_DIR}/tests/CAD/${datafile} COPYONLY)
  endforeach()
  
  build_python_tests(
    DEPS Boost::boost # for quaternions
    # ${COMPONENT} # some plugins in tests need to be linked with kernel
    )
endif()

=== debian/changelog ===
siconos (4.3.1+dfsg-2) unstable; urgency=medium

  * Disable test ContactTest due to timeout on arm64.
  * Disable test ConvexQP_test_collection due to timeout.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 25 Jan 2021 19:50:26 +0100

siconos (4.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Rebase patches:
    + Remove upstreamed patch to FindLAPACK.cmake.
  * Update policy version 4.5.1.
  * Update debhelper version 13.
  * Add missing symbols for numerics.
  * Change architecture for siconos and siconos-mechanics-tools to all.
  * Add debian/upstream/metadata.
  * Replace debian/compat with debhelper-compat package.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 12 Dec 2020 18:31:54 +0000

siconos (4.3.0+dfsg-3) unstable; urgency=medium

  * Patch to fix indexing bug in siconos_filter program.  (Closes: #974184)
  * Patch to suppress a warning due to CMake's FindBoost in siconos script.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 28 Nov 2020 22:00:41 +0000

siconos (4.3.0+dfsg-2) unstable; urgency=medium

  * Set Python3_EXECUTABLE instead of PYTHON_EXECUTABLE.
    (Closes: #972394)
  * Skip test dr_iso1 due to occasional timeout.

 -- Stephen Sinclair <radarsat1@gmail.com>  Tue, 27 Oct 2020 19:05:25 +0000

=== debian/control ===
Source: siconos
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephen Sinclair <radarsat1@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 13),
               debhelper-compat (= 13),
               dh-python,
               cmake (>= 3.0.2),
               libhdf5-dev (>= 1.10),
               libsuitesparse-dev (>= 1:5.1.2),
               libgmp3-dev,
               swig,
               libmumps-seq-dev,
               doxygen,
               graphviz,
               help2man,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               python3-sphinxcontrib.bibtex,
               python3-breathe,
               libbullet-dev,
               libboost-graph-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-timer-dev,
               libboost-chrono-dev,
               liblpsolve55-dev,
               liblapacke-dev,
               libopenblas-dev,
               gfortran,
               libcppunit-dev,
               libfclib-dev (>= 3.1.0),
               python3-lxml,
               python3-scipy,
               python3-numpy,
               python3-pytest,
               python3-vtk7,
               python3-h5py,
               python3-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/siconos
Vcs-Git: https://salsa.debian.org/science-team/siconos.git
Homepage: https://nonsmooth.gricad-pages.univ-grenoble-alpes.fr/siconos/index.html
Rules-Requires-Root: no
X-Python3-Version: >= 3.8

Package: siconos
Architecture: all
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         cmake,
         libboost-serialization-dev (>= 1.61),
         libboost-filesystem-dev (>= 1.61),
         libsiconos-numerics-dev (>= ${source:Version}),
         libsiconos-kernel-dev (>= ${source:Version}),
         libsiconos-control-dev (>= ${source:Version}),
         libsiconos-mechanics-dev (>= ${source:Version}),
         libsiconos-io-dev (>= ${source:Version})
Description: modeling and simulation of nonsmooth dynamical systems (simulation runner tool)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the 'siconos' tool allowing to compile and run
 Siconos programs/scripts in a single command.

Package: siconos-mechanics-tools
Architecture: all
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         python3-siconos (>= ${source:Version}),
         python3-h5py (>= 2.8.0-1),
         python3-vtk7
Description: modeling and simulation of nonsmooth dynamical systems (mechanics tools)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains tools to allow running, analysing, manipulating,
 exporting, and viewing the output of mechanical simulations.

Package: libsiconos-numerics6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: modeling and simulation of nonsmooth dynamical systems (numerics lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the numerics component of
 Siconos, an interface to a collection of common numerical solvers.

Package: libsiconos-numerics-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libhdf5-dev (>= 1.10),
         libsuitesparse-dev (>= 1:5.1.2)
Description: modeling and simulation of nonsmooth dynamical systems (numerics dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the numerics
 component of Siconos, an interface to a collection of common
 numerical solvers.

Package: libsiconos-kernel6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (kernel lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the kernel component of Siconos.

Package: libsiconos-kernel-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-kernel6 (= ${binary:Version}),
         libsiconos-numerics-dev (= ${binary:Version}),
         libfclib-dev (>= 3.1.0),
         libsuitesparse-dev (>= 1:5.1.2),
         libboost-dev (>= 1.62.0.1),
         libgmp-dev (>= 2:6.1.2+dfsg-3)
Description: modeling and simulation of nonsmooth dynamical systems (kernel dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the kernel
 component of Siconos.

Package: libsiconos-control6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libsiconos-kernel6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the control component of Siconos.

Package: libsiconos-control-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-control6 (= ${binary:Version}),
         libsiconos-kernel-dev (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).

=== debian/tests/control ===
Tests: kernel-dev
Depends: build-essential, libsiconos-kernel-dev, cmake, shunit2

Tests: numerics-tests kernel-tests control-tests
Depends: build-essential, siconos, libcppunit-dev, shunit2

Tests: kernel-tests-python, control-tests-python
Depends: python3-siconos, shunit2

Tests: mechanics-tests
Depends: build-essential, siconos, libbullet-dev, libcppunit-dev, shunit2

Tests: mechanics-tests-python
Depends: python3-siconos, shunit2

Tests: mechanics-tools
Depends: siconos-mechanics-tools, python3-vtk7, python3-scipy, file, shunit2
